################################################################################
####                             Functions                                  ####
################################################################################
data_matrix <- function(data){
  d <- as.data.frame(matrix(NA,length(data),2))
  colnames(d) <- c('name','sequence')
  d$name <- names(data)
  d$sequence <- as.character(data)
  return(d)
}

str2token <- function(str_sequence) {
  splitted_seq <- strsplit(str_sequence, '')
  token_seq <- vector(mode='list', length=length(splitted_seq))
  
  for (idx in c(1:length(splitted_seq))){
    token_seq[idx] = list(as.integer(unlist(splitted_seq[idx]) == 'A') +
                            2 * as.integer(unlist(splitted_seq[idx]) == 'C') +
                            3 * as.integer(unlist(splitted_seq[idx]) == 'G') +
                            4 * as.integer(unlist(splitted_seq[idx]) == 'U'))
  }
  return(token_seq)
}


prediction_result <- function(data,result){
  d <- data
  d$probability <- result
  d$tissue <- tm
  d$cutoff <- t
  d$class <- 'm6A negative region'
  indx <- which(d$probability >= t)
  if(length(indx) != 0){
    d$class[indx] <- 'm6A positive region'
  }
  return(d)
}













