################################################################################
####                   tissue-specific m6A prediction model                 ####
################################################################################
setwd('/home/bowen.song/m6acsvar/server_script/')  # Setting working director
file <- './example.txt'                            # Your can query your own sequences following the format of example file showed
t <- '0.5'                                         # Give a threshold
tm <- 'lung'                                       # Select a tissue-specific model, please refer to ./tissue_model/ for all tissues
source('./Functions.R')


####1 
library(Biostrings)
data <- readBStringSet(file)
result_matrix <- data_matrix(data)


####2 to token
ref <- result_matrix$sequence
ref <- gsub('T','U',ref)
ref_token <- str2token(ref)
saveRDS(ref_token,'./file_token.rds')


####3 token2pred
system(paste0('python ./token2pred.py -i ./ -o ./ -t ',tm,' -c ./tissue_model/ -j 1 -l 40 -s 5'))
# please make sure you already loaded all required packages for prediction  


####4 
result <- as.numeric(read.table('./result.txt'))
prediction_output <- prediction_result(result_matrix,result)


##############################################################################
################################################################ end of script