import os
import time
os.chdir('/home/bowen.song/m6acsvar/webserver/scripts/Lung/')
import itertools
import numpy as np
import tensorflow as tf
from mynets import WSCNN, WSCNNLSTM, WeakRM, WeakRMLSTM
os.environ['CUDA_VISIBLE_DEVICES'] = '7'


tfk = tf.keras
tfkl = tf.keras.layers
tfkc = tf.keras.callbacks

instance_len = 40
instance_stride = 5
merging = 'base'
num_epoch = 40
model_name = 'WeakRM'
tissue_name = 'Heart'

    
data_dir = '/home/bowen.song/m6acsvar/58web/tissue/' + tissue_name + '/'
target_dir = '/home/bowen.song/m6acsvar/webserver/data_for_mil/'

checkpoint_filepath = data_dir + model_name + '_' + merging + '.h5'
print('Load weights from:', checkpoint_filepath)

print('loading data')
itest_data = np.load('/home/bowen.song/m6acsvar/webserver/data_for_mil/example.npy', allow_pickle=True)
print('creating model')

if isinstance(model_name, str):
  dispatcher = {'WeakRM': WeakRM,
                'WeakRMLSTM': WeakRMLSTM,
                'WSCNN': WSCNN,
                'WSCNNLSTM': WSCNNLSTM}
try:
  model_funname = dispatcher[model_name]

except KeyError:
  raise ValueError('invalid input')

if model_name.startswith('Weak'):
  model = model_funname()
else:
  model = model_funname(merging=merging)

model(itest_data[0].reshape(1, -1, instance_len, 4).astype(np.float32))
model.load_weights(checkpoint_filepath)

print('prediction start')
predictions = []

for idx, tdata in enumerate(itest_data):
  start_time = time.time()
  pred, _ = model(tdata.reshape(1, -1, instance_len, 4), training=False)
  predictions.append(pred.numpy())
  print("{}/{} finished! Time costs: {}s.".format(int(idx+1), len(itest_data), np.round(time.time() - start_time, 2)))

predictions = np.concatenate(predictions, axis=0)

np.save(target_dir + 'result.npy', predictions)
# predictions = np.load(target_dir + 'positive_alt_result.npy', allow_pickle=True)
    
result = predictions.reshape(1,-1)
np.savetxt(target_dir + 'result.txt',result,delimiter='\t')
    









