import os
import numpy as np
import rpy2.robjects as ro


np.random.seed(323)

readRDS = ro.r['readRDS']


data_dir = '/home/bowen.song/m6acsvar/webserver/'
target_dir = data_dir + 'data_for_mil/'
if not os.path.exists(target_dir):
  os.mkdir(target_dir)
        
def embed(sequence, instance_len, instance_stride):
  instance_num = int((len(sequence)-instance_len)/instance_stride) + 1
  bag = []
  
  for i in range(instance_num):
    instance = sequence[i*instance_stride:i*instance_stride+instance_len]
    bag.append(instance)
    bag = np.stack(bag).astype(np.int32)
    one_hot_bag = np.eye(4)[bag - 1].astype(np.float32)
    return one_hot_bag
        
instance_len = 40
instance_stride = 5
        
        
test_seq = readRDS(data_dir + 'example_token.rds')
test_seq = np.asarray(test_seq)
test_seq = [np.asarray(seq) for seq in test_seq]
        
test_bags = []
        
for seq in test_seq:
  ont_hot_bag = embed(seq, instance_len, instance_stride)
  test_bags.append(ont_hot_bag)
            
test_bags = np.asarray(test_bags)
np.save(target_dir + 'example.npy', test_bags)
