import os
import numpy as np


def create_folder(folder_path):
    if not os.path.exists(folder_path):
        os.mkdir(folder_path)


def one_hot_bag_embedding(sequence, instance_len, instance_stride):
    instance_num = int((len(sequence)-instance_len)/instance_stride) + 1
    bag = []
    for i in range(instance_num):
        instance = sequence[i*instance_stride:i*instance_stride+instance_len]
        bag.append(instance)
    bag = np.stack(bag).astype(np.int32)
    one_hot_bag = np.eye(4)[bag - 1]
    return one_hot_bag